/*
JRater Applet - an applet that approximates a USCF rating based on a tournament.
Copyright (C) 2012 Cory Fosmire

This file is part of the JRater Applet.

JRater is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

JRater is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JRater.  If not, see <http://www.gnu.org/licenses/>.
*/
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
	 * This dialog is used to explain error codes.
	 * @param owner the JFrame that the dialog will be added to.
	 */
public class ErrorDialog extends JDialog
{
	
	private static final long serialVersionUID = -6018345652099338358L;

	public ErrorDialog(JFrame owner)
	{
		super(owner, "Error codes", true);
		Container contentPane = getContentPane();
		contentPane.add(new JLabel("<HTML><I>Error codes</I><HR>"
				+ "00 = Illegal state exception.<HR>"
				+ "01 = A value could not be parsed.<HR>"
				+ "02 = Arithmetic Exception(Division by zero)<HR>"
				+ "03 = File is not formatted correctly"
				),BorderLayout.CENTER);
		
		JButton ok = new JButton("OK");
		ok.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				setVisible(false);
			}
		});
		JButton help = new JButton("More");
		help.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				try 
				{
					Process p = Runtime
							.getRuntime()
							.exec("rundll32 url.dll,FileProtocolHandler C:/Users/Shamrock/workspace/Rating/userguide.pdf");
					p.waitFor();
				} 
				catch (Exception ex)
				{
					ex.printStackTrace();
				}
			}
		});
		JPanel p = new JPanel();
		p.add(ok);
		p.add(help);
		contentPane.add(p, BorderLayout.SOUTH);
		
		setSize(300,200);
	}
}
