/*
JRater Applet - an applet that approximates a USCF rating based on a tournament.
Copyright (C) 2012 Cory Fosmire

This file is part of the JRater Applet.

JRater is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

JRater is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JRater.  If not, see <http://www.gnu.org/licenses/>.
*/
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;
/**
	 * An Exception that writes to a file.
	 * @param error the text that is to be written.
	 */
public class InvalidTextException extends Exception
{
	
	private static final long serialVersionUID = 1L;

	public InvalidTextException(String error)
	{
		System.err.println(error);
		try
		{
			PrintWriter out  = new PrintWriter(new FileWriter("error.log",true));
			out.println(new Date());
			out.println(error);
			out.close();
			BufferedReader in = new BufferedReader(new FileReader("error.log"));
			int b = in.read();  
			if (b == -1)  
			{  
			  System.out.println("File error.log empty.");  
			} 
			in.close();
		}
		catch(IOException e)
		{
			e.printStackTrace();
		}
	}
}