/*
JRater Applet - an applet that approximates a USCF rating based on a tournament.
Copyright (C) 2012 Cory Fosmire

This file is part of the JRater Applet.

JRater is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

JRater is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JRater.  If not, see <http://www.gnu.org/licenses/>.
*/

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.*;
import javax.swing.event.*;
/**
	 * This frame calculates rating for over 50 games.
	 * @param n = number of games
	 */
public class LolPanel extends JPanel
{
	
	private static final long serialVersionUID = -2212035575385015632L;
	public LolPanel(int n)
	{
		setSize(500,500);
		E = 0;
		N = n;
		eger = 0;
		S = 0;
		i = 0;
		more = true;
		JLabel rating = new JLabel("Rating");
		rating.setToolTipText("Enter your pre-tournament rating");
		rate = 0;
		add(rating);
		text = new JTextField("0",5);
		text.getDocument().addDocumentListener(new DocumentListener()
		{
			public void insertUpdate(DocumentEvent e)
			{
				try
				{
				rate = Integer.parseInt(text.getText().trim());
				if(rate < 0||rate > 3000)throw new NumberFormatException();
				}
				catch(NumberFormatException nf)
				{
					ErrorMessage(LolPanel.this,"Rating value unable to be parsed. Error code = 01\nPlease make sure your rating is between 0 and 3000.",01);
				}
			}
			public void removeUpdate(DocumentEvent e){}
			public void changedUpdate(DocumentEvent e)
			{
				try
				{
				rate = Integer.parseInt(text.getText().trim());
				if(rate < 0||rate > 3000)throw new NumberFormatException();
				}
				catch(NumberFormatException nf)
				{
					ErrorMessage(LolPanel.this,"Rating value unable to be parsed. Error code = 01\nPlease make sure your rating is between 0 and 3000.",01);
				}
			}
		});

		add(text);
		KCombo = new JComboBox<String>();
		KCombo.addItem("Full");
		KCombo.addItem("Half");
		JLabel k = new JLabel("K Factor");
		k.setToolTipText("The magnitude of rating changes");
		add(k);
		add(KCombo);
		JButton opponent = new JButton("New Opponent");
		add(opponent, BorderLayout.SOUTH);
		opponent.addActionListener(new ActionListener()
		{
			/**
			 * An ActionListener that basically initializes all the values not in getA()
			 */
			public void actionPerformed(ActionEvent e)
			{
				if(i > 0)
					{
						dump();
						more = true;
					}

					your_arm:
						while(more)
						{
							if(rate == 0) 
							{
								JOptionPane.showMessageDialog(LolPanel.this, "Input your own rating");
								break your_arm;
							}
				
							try
							{
								String input = JOptionPane.showInputDialog(LolPanel.this,"What was your opponent's rating?");
								f = Integer.parseInt(input);
								if(f < 0 || f > 3000) throw new NumberFormatException();
							}
							catch(NumberFormatException E)
							{
								ErrorMessage(LolPanel.this, "Unable to parse integer. Error code = 01\nPlease make the rating between 0 and 3000.",01);
								break your_arm;
							}
							Object[] options = {"Win",
				                    "Loss",
				                    "Draw"};
							int n = JOptionPane.showOptionDialog(LolPanel.this,
									"What was the game's result?",
											"Input",
											JOptionPane.YES_NO_CANCEL_OPTION,
											JOptionPane.QUESTION_MESSAGE,
											null,
											options,
											options[0]);
							if(n == 0)
								{
									S += 1;
									System.out.println(S);
								}
							if(n == 2)
							{
								S += 0.5;
							}
							Object[] yesno = new Object[]{"Yes","No"};
							int te = JOptionPane.showOptionDialog(LolPanel.this,"More Opponents?", "More",
									JOptionPane.YES_NO_OPTION,
									JOptionPane.QUESTION_MESSAGE, 
									null,
									yesno,
									yesno[0]);
							if(te == 1)more = false;
							if(more == false)i++;
							setA();
						}
				}
			});
		
	}
	public void setN(int d)
	/**
	 * A utility that sets the value of N. Not used currently.
	 * @param d = new value for N.
	 */
	{
		N = d;
	}
	public void paint(Graphics g)
	{
		super.paint(g);
		try 
		{
			redcanoe =ImageIO.read(LolPanel.class.getResource("red.jpg"));;
		} 
		catch (IOException e) 
		{
			e.printStackTrace();
		}
		g.drawImage(redcanoe,0,50,350,350,null);
	}
	public void dump()
	{
		/**
		 * Destroys all data to restart the new opponent loop.
		 */
		K = 0;
		E = 0;
		B = 0;
		S = 0;
		eger = 0;
		ns = 0;
		more = true;
	}
	public void setA()
	{
		/**
		 * This is the method that sets the new rating and calculates some amounts.
		 */
		ns = 50 / Math.sqrt(1 + Math.pow(2200 - rate, 2)/100000); 
		
		if (ns > N) ns = N;
		
		double yinz = 1 / (1 + (Math.pow(10, -(rate-f)/400)));
		System.out.println("f= "+ f);
		System.out.println("rate=" + rate);
		System.out.println("yinz= " + yinz);
		E += yinz;
		eger++;
		
		String j = (String) KCombo.getSelectedItem();
		System.out.println("ns=" +ns);
		System.out.println("eger=" + eger);
		if(j.equals("Full"))K = 800/(ns+eger);
		if(j.equals("Half"))K = 400/(ns+eger/2);
		
		B = K * (S - E) -10* Math.sqrt(eger);
		if(B < 0) B = 0;
		System.out.println(ns);
		System.out.println(rate +"+" + K +"*" +"("  + S + "-" + E + ")" + "+" + B + "=" +(rate + K * (S - E) + B));
		double post = Math.round(rate + K * (S - E) + B);
		String posts = "" + post;
		LolSouth.a.setText(posts);
	}
	public void ErrorMessage(Component c, String s,int ec)
	{
		JOptionPane.showMessageDialog(c,
			    s,
			    "Error",
			    JOptionPane.ERROR_MESSAGE);
	}
	/**
	 * A utility field to reset the opponent process
	 */
	private int i;
	/**
	 * A double that calculates winning expectancy
	 */
	private double eger;
	/**
	 * A value that determines whether the opponent loop should keep runnin
	 */
	private boolean more;
	/**
	 * The number of games played
	 */
	private int N;
	/**
	 * The possible values of the rating magnitude
	 */
	private JComboBox<String> KCombo; 
	/**
	 * The initial rating is inputted here
	 */
	private JTextField text;
	/**
	 * The number of effective games played
	 */
	private double ns;
	/**
	 * The current rating
	 */
	private double rate;
	/**
	 * The magnitude of rating changes
	 */
	private double K;
	/**
	 * The total winning expectancy for all games
	 */
	private double E;
	/**
	 * The bonus of all games
	 */
	private double B;
	/**
	 * The cumulative score in the tournament.
	 */
	private float S;
	/**
	 * The new rating field
	 */
	private JTextField a;
	/**
	 * The opponent's rating
	 */
	private double f;
	private Image redcanoe;
	public static void main(String[]args)
	{
		JFrame test = new JFrame();
		test.add(new LolPanel(50));
		test.setSize(500,500);
		test.setVisible(true);
	}

}
class DPanel extends JPanel
{
	
	private static final long serialVersionUID = 1L;
	public DPanel(int w, int h)
	{
		W = w;
		H = h;
		try 
		{
			image = ImageIO.read(new File("Images/red.jpg"));
		} 
		catch (IOException e) 
		{
			e.printStackTrace();
		}
	}
	public void paint(Graphics g)
	{
		super.paintComponent(g);

		g.drawImage(image, 0 , 0,W,H, null);
	}
	/**
	 * The image that shall be drawn
	 */
	private Image image;
	/**
	 * The image's width
	 */
	private int W;
	/**
	 * The image's height
	 */
	private int H;
	public static void main(String[]args)
	{
		JFrame f = new JFrame();
		f.setSize(500,500);
		f.add(new SizePanel(400,400));
		f.setVisible(true);
	}
}
