/*
JRater Applet - an applet that approximates a USCF rating based on a tournament.
Copyright (C) 2012 Cory Fosmire

This file is part of the JRater Applet.

JRater is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

JRater is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JRater.  If not, see <http://www.gnu.org/licenses/>.
*/

import java.awt.*;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.*;
/**
 * The main applet class, which displays a splash screen. The panels are changed
 * by the CardLayout when the buttons are clicked.
 * @author Shamrock
 */
public class RaterApplet extends JApplet 
{
	private static final long serialVersionUID = 1L;
	public void init()
	{
		setSize(350,450);
		final String StrRating = "Rating";
		final String choices = "choices";
		final String less = "Less";
		final String StrSouth = "South";
		south = new JPanel(new CardLayout());
		cards = new JPanel(new CardLayout());
		rating = new RatingPanel();
		north = new RatingNorth();
		lt8 = new lt8Panel();
		south8 = new Lt8South();
		loller = new LolPanel(50);
		lollersouth = new LolSouth();
		
		cards.add(north,choices);
		cards.add(lt8,less);
		cards.add(loller,lolStr);
		cl = (CardLayout)(cards.getLayout());
		cl.show(cards, choices);
		south.add(rating,StrRating);
		south.add(south8,StrSouth);
		south.add(lollersouth,lolsouth);
		scl = (CardLayout)(south.getLayout());
		scl.show(south,StrRating);
		add(cards);
		add(south,BorderLayout.SOUTH);
	}
	public static void destroy(JPanel j)
	{
		cl.removeLayoutComponent(j);
	}
	public static void addComponent(JPanel j,String f)
	{
		cards.add(j,f);
	}
	public static void destroySouth(JPanel j)
	{
		scl.removeLayoutComponent(j);
	}
	public static void addSouthComponent(JPanel j, String f)
	{
		south.add(j,f);
	}
	public void paint(Graphics g)
	{
		super.paint(g);
		try 
		{
			redcanoe = ImageIO.read(RaterApplet.class.getResource("red.jpg"));
		} 
		catch (IOException e) 
		{
			e.printStackTrace();
		}
		g.drawImage(redcanoe,0,50,350,350,null);
	}
	public static void changeCards(String which)
	{
		if(which.equals("LOL"))
		{
			cl.show(cards,lolStr);
			scl.show(south, lolsouth);
			paint = true;
		}
		else if(which.equals("LT*"))
		{
			destroySouth(rating);
			destroy(north);
			paint = true;
		}
	}
	public void painter()
	{
		if(paint)repaint();
	}
	private static JPanel cards;
	private static JPanel south;
	private static JPanel lt8;
	private static JPanel south8;
	private static JPanel rating;
	private static JPanel north;
	public static JPanel loller;
	private static JPanel lollersouth;
	private static CardLayout cl;
	private static CardLayout scl;
	private static boolean paint = false;
	private static final String lolStr = "LOL";
	private static final String lolsouth = "Lolsouth";
	public static JTextField answer;
	private Image redcanoe;
}