/*
JRater Applet - an applet that approximates a USCF rating based on a tournament.
Copyright (C) 2012 Cory Fosmire

This file is part of the JRater Applet.

JRater is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

JRater is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JRater.  If not, see <http://www.gnu.org/licenses/>.
*/
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.*;

import javax.imageio.*;
import javax.swing.*;



public class RatingPanel extends JPanel
{
	private static final long serialVersionUID = 1771259183211103324L;
	public RatingPanel()
	{
		buttonPanel = new JPanel();
		group = new ButtonGroup();
		JRadioButton one = new JRadioButton("Less than 8");
		JRadioButton nine = new JRadioButton("9-49");
		JRadioButton fifty = new JRadioButton("50 or more");
		
		Font Radio = new Font("SansSerif",Font.BOLD,15);
		one.setFont(Radio);
		fifty.setFont(Radio);
		nine.setFont(Radio);
		
		group.add(one);
		group.add(nine);
		group.add(fifty);
		buttonPanel.add(new JSeparator(JSeparator.VERTICAL),BorderLayout.EAST);
		buttonPanel.add(one,BorderLayout.SOUTH);
		buttonPanel.add(nine,BorderLayout.SOUTH);
		buttonPanel.add(fifty,BorderLayout.SOUTH);
		add(buttonPanel, BorderLayout.SOUTH);
		
		one.addActionListener(new ActionListener()
		{
			/**
			 * An ActionListener that makes a lessthan8Frame
			 */
			public void actionPerformed(ActionEvent e)
			{
				RaterApplet.changeCards("LT*");
			}
		});
		nine.addActionListener(new ActionListener()
		{
			/**
			 * Creates a LolFrame with the specified number of games.
			 */
			public void actionPerformed(ActionEvent e)
			{
				try
				{
					String input = JOptionPane.showInputDialog(RatingPanel.this,"How many games have you played?");
					int j = Integer.parseInt(input);
					RaterApplet.loller = new LolPanel(j);
					RaterApplet.changeCards("LOL");
				}
				catch(NumberFormatException nfe)
				{
					JOptionPane.showMessageDialog(RatingPanel.this, "That value could not be parsed. Error Code = 01");
				}
			}
		});
		fifty.addActionListener(new ActionListener()
			/**
			 * Same as nine's ActionListener with a default value of 50.
			*/
		{
			public void actionPerformed(ActionEvent e)
			{
				RaterApplet.changeCards("LOL");
			}
		});
	}
	/**
	 * A panel with buttons
	 */
	private JPanel buttonPanel;
	/**
	 * The group the radio buttons are added to
	 */
	private ButtonGroup group;
	private Image redcanoe;
	public static void main(String[]args)
	{
		JFrame f = new JFrame();
		f.setSize(500,500);
		f.add(new RatingPanel());
		f.setVisible(true);
	}
}
