/*
JRater Applet - an applet that approximates a USCF rating based on a tournament.
Copyright (C) 2012 Cory Fosmire

This file is part of the JRater Applet.

JRater is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

JRater is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JRater.  If not, see <http://www.gnu.org/licenses/>.
*/

import java.awt.Graphics;
import java.awt.Image;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JPanel;
/**
	 * A panel that lets your specify your own image size.
	 * @param w the width.
	 * @param h the height.
	 */
public class SizePanel extends JPanel
{
	
	private static final long serialVersionUID = 1L;
	public SizePanel(int w, int h)
	{
		W = w;
		H = h;
		ImageIcon icon = new ImageIcon(this.getClass().getResource("red.jpg"));
		image = icon.getImage();
	}
	public void paint(Graphics g)
	{
		super.paintComponent(g);

		g.drawImage(image, 0 , 0,W,H, null);
	}
	/**
	 * The image that shall be drawn
	 */
	private Image image;
	/**
	 * The image's width
	 */
	private int W;
	/**
	 * The image's height
	 */
	private int H;
	public static void main(String[]args)
	{
		JFrame f = new JFrame();
		f.setSize(500,500);
		f.add(new SizePanel(400,400));
		f.setVisible(true);
	}
}
